searchNodes=[{"doc":"Luminous Luminous is a framework for creating dashboards within Phoenix Live View . It is somewhat inspired by grafana both conceptually and functionally in that: it focuses on time series data (albeit not exclusively) it is organized around panels it is parameterized by a time range it can be parameterized by user-defined variables Dashboards are defined at compile time using elixir code (see Luminous.Dashboard.define/5 ). At runtime, Luminous uses the following javascript libraries (as live view hooks ) for supporting client-side visualizations and interactions with the live view process: chartjs for plots flatpickr for time range selection Luminous is currently used in production systems and has demonstrated solid performance and stability characteristics. At the same time, it is currently under development and some things may change. Installation The package is not yet published to hex.pm but can be installed directly from this repo by adding luminous to your list of dependencies in mix.exs like so: def deps do [ { :luminous , git : &quot;https://github.com/elinverd/luminous.git&quot; , branch : &quot;main&quot; } ] end luminous assumes that it will be embedded in a standard Phoenix LiveView application with tailwindcss . In order to be able to use the provided components, the library's javascript and CSS files must be imported to your project: In assets/package.json : ... &quot;dependencies&quot;: { &quot;luminous&quot;: &quot;file:../deps/luminous&quot; } In assets/js/app.js : import { ChartJSHook, TimeRangeHook } from &quot;luminous&quot; let Hooks = { TimeRangeHook: new TimeRangeHook(), ChartJSHook: new ChartJSHook() } ... let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, { ... hooks: Hooks }) ... Finally, in assets/css/app.css : @import &quot;luminous/dist/luminous&quot;; Usage A demo dashboard has been provided that showcases some of Luminous' capabilities. The demo can be inspected live using the project's dev server (run mix dev in the project and then visit this page ). Luminous is a framework in the sense that the luminous client is responsible for specifying queries, variables etc. and Luminous.Live will call the client's code by setting up all the required plumbing. In general, a custom dashboard needs to: implement the Luminous.Variable behaviour for the dashboard-specific variables implement the Luminous.Query behaviour for loading the necessary data that will be visualized in the client implement the Luminous.TimeRangeSelector behaviour for determining the default time range for the dashboard use the Luminous.Live module for leveraging the live dashboard functionality and capabilities render the dashboard in the view template (only Luminous.Components.dashboard is necessary but the layout can be customized by using directly the various components in Luminous.Components ) Features Time range selection and refresh of all dashboard panel queries Asynchronous queries and page updates User-facing variable dropdowns that are available to panel queries Client-side zoom in charts Multiple supported chart types (currently :line and :bar ) Download panel data (CSV, PNG) Stat panels (show single or multiple stats) Summary statistics in panels Development Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/luminous .","ref":"Luminous.html","title":"Luminous","type":"module"},{"doc":"","ref":"Luminous.Components.html","title":"Luminous.Components","type":"module"},{"doc":"the dashboard component is responsible for rendering all the necessary elements: title variables time range selector panels it also registers callbacks for reacting to panel loading states","ref":"Luminous.Components.html#dashboard/1","title":"Luminous.Components.dashboard/1","type":"function"},{"doc":"","ref":"Luminous.Components.html#description/1","title":"Luminous.Components.description/1","type":"function"},{"doc":"this component registers the js event listeners for the panel spinners","ref":"Luminous.Components.html#listeners/1","title":"Luminous.Components.listeners/1","type":"function"},{"doc":"this component is responsible for rendering the panel's data depending on the panel's type, there will be a different visualization","ref":"Luminous.Components.html#panel/1","title":"Luminous.Components.panel/1","type":"function"},{"doc":"","ref":"Luminous.Components.html#panel_id/1","title":"Luminous.Components.panel_id/1","type":"function"},{"doc":"","ref":"Luminous.Components.html#panel_statistics/1","title":"Luminous.Components.panel_statistics/1","type":"function"},{"doc":"","ref":"Luminous.Components.html#time_range/1","title":"Luminous.Components.time_range/1","type":"function"},{"doc":"","ref":"Luminous.Components.html#variable/1","title":"Luminous.Components.variable/1","type":"function"},{"doc":"A dashboard is a high-level component initialized by the dashboard live view it contains all the necessary dashboard attributes such as the panels, variables and the time range selector it is initialized at compile time using define/4 and populated at runtime using populate/1","ref":"Luminous.Dashboard.html","title":"Luminous.Dashboard","type":"module"},{"doc":"return the dashboard's default time range","ref":"Luminous.Dashboard.html#default_time_range/1","title":"Luminous.Dashboard.default_time_range/1","type":"function"},{"doc":"initialize a dashboard at compile time","ref":"Luminous.Dashboard.html#define/5","title":"Luminous.Dashboard.define/5","type":"function"},{"doc":"return the LV path for the specific dashboard based on its configuration","ref":"Luminous.Dashboard.html#path/3","title":"Luminous.Dashboard.path/3","type":"function"},{"doc":"populate the dashboard's dynamic properties (e.g. variable values, time range etc.) at runtime","ref":"Luminous.Dashboard.html#populate/1","title":"Luminous.Dashboard.populate/1","type":"function"},{"doc":"update the dashboard's current time range with a new one","ref":"Luminous.Dashboard.html#update_current_time_range/2","title":"Luminous.Dashboard.update_current_time_range/2","type":"function"},{"doc":"update the dashboard's variables with a new list","ref":"Luminous.Dashboard.html#update_variables/2","title":"Luminous.Dashboard.update_variables/2","type":"function"},{"doc":"","ref":"Luminous.Dashboard.html#t:t/0","title":"Luminous.Dashboard.t/0","type":"type"},{"doc":"","ref":"Luminous.Dashboards.DemoDashboardLive.html","title":"Luminous.Dashboards.DemoDashboardLive","type":"module"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"Luminous.Dashboards.DemoDashboardLive.html#render/1","title":"Luminous.Dashboards.DemoDashboardLive.render/1","type":"function"},{"doc":"This is where we implement the Query behaviour, i.e. all queries that will be visualized in the dashboard's panels (a panel can have multiple queries). All queries have access to the current dashboard variable values and the selected time range. All queries must return a Query.Result with optional attributes that specify the visual characteristics of the particular data set (see Query.Attributes ). More details in Lumninous.Query .","ref":"Luminous.Dashboards.DemoDashboardLive.Queries.html","title":"Luminous.Dashboards.DemoDashboardLive.Queries","type":"module"},{"doc":"This is where we implement the Variable behaviour, i.e. define the dashboard's variables displayed as dropdowns in the view The first value in each list is the default one. Values can be either simple (a single binary) or descriptive (label different than the value). Variables values are available within queries where they can serve as parameters. More details in Luminous.Variable .","ref":"Luminous.Dashboards.DemoDashboardLive.Variables.html","title":"Luminous.Dashboards.DemoDashboardLive.Variables","type":"module"},{"doc":"","ref":"Luminous.Dashboards.TestDashboardLive.html","title":"Luminous.Dashboards.TestDashboardLive","type":"module"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"Luminous.Dashboards.TestDashboardLive.html#render/1","title":"Luminous.Dashboards.TestDashboardLive.render/1","type":"function"},{"doc":"","ref":"Luminous.Dashboards.TestDashboardLive.Queries.html","title":"Luminous.Dashboards.TestDashboardLive.Queries","type":"module"},{"doc":"","ref":"Luminous.Dashboards.TestDashboardLive.Variables.html","title":"Luminous.Dashboards.TestDashboardLive.Variables","type":"module"},{"doc":"","ref":"Luminous.Endpoint.html","title":"Luminous.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"Luminous.Endpoint.html#broadcast/3","title":"Luminous.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"Luminous.Endpoint.html#broadcast!/3","title":"Luminous.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"Luminous.Endpoint.html#broadcast_from/4","title":"Luminous.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"Luminous.Endpoint.html#broadcast_from!/4","title":"Luminous.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Luminous.Endpoint.html#call/2","title":"Luminous.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"Luminous.Endpoint.html#child_spec/1","title":"Luminous.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"Luminous.Endpoint.html#config/2","title":"Luminous.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"Luminous.Endpoint.html#config_change/2","title":"Luminous.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"Luminous.Endpoint.html#host/0","title":"Luminous.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Luminous.Endpoint.html#init/1","title":"Luminous.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"Luminous.Endpoint.html#local_broadcast/3","title":"Luminous.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"Luminous.Endpoint.html#local_broadcast_from/4","title":"Luminous.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"Luminous.Endpoint.html#path/1","title":"Luminous.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"Luminous.Endpoint.html#script_name/0","title":"Luminous.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. Options :log_access_url - if the access url should be logged once the endpoint starts All other options are merged into the endpoint configuration.","ref":"Luminous.Endpoint.html#start_link/1","title":"Luminous.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"Luminous.Endpoint.html#static_integrity/1","title":"Luminous.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"Luminous.Endpoint.html#static_lookup/1","title":"Luminous.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"Luminous.Endpoint.html#static_path/1","title":"Luminous.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"Luminous.Endpoint.html#static_url/0","title":"Luminous.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"Luminous.Endpoint.html#struct_url/0","title":"Luminous.Endpoint.struct_url/0","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.subscribe/2 .","ref":"Luminous.Endpoint.html#subscribe/2","title":"Luminous.Endpoint.subscribe/2","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.unsubscribe/1 .","ref":"Luminous.Endpoint.html#unsubscribe/1","title":"Luminous.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"Luminous.Endpoint.html#url/0","title":"Luminous.Endpoint.url/0","type":"function"},{"doc":"","ref":"Luminous.ErrorView.html","title":"Luminous.ErrorView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"Luminous.ErrorView.html#__resource__/0","title":"Luminous.ErrorView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"Luminous.ErrorView.html#render/2","title":"Luminous.ErrorView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"Luminous.ErrorView.html#template_not_found/2","title":"Luminous.ErrorView.template_not_found/2","type":"function"},{"doc":"","ref":"Luminous.Generator.html","title":"Luminous.Generator","type":"module"},{"doc":"","ref":"Luminous.Generator.html#generate/4","title":"Luminous.Generator.generate/4","type":"function"},{"doc":"","ref":"Luminous.Helpers.html","title":"Luminous.Helpers","type":"module"},{"doc":"interpolate all occurences of variable IDs in the format $variable.id in the string with the variable's descriptive value label e.g. the string: &quot;Energy for asset $asset_var&quot; will be replaced by the label of the variable with id :asset_var in variables","ref":"Luminous.Helpers.html#interpolate/2","title":"Luminous.Helpers.interpolate/2","type":"function"},{"doc":"","ref":"Luminous.Live.html","title":"Luminous.Live","type":"module"},{"doc":"a panel represents a single visual element (chart) in a dashboard contains many queries","ref":"Luminous.Panel.html","title":"Luminous.Panel","type":"module"},{"doc":"initialize a panel at compile time","ref":"Luminous.Panel.html#define/5","title":"Luminous.Panel.define/5","type":"function"},{"doc":"refresh all panel queries","ref":"Luminous.Panel.html#refresh/3","title":"Luminous.Panel.refresh/3","type":"function"},{"doc":"","ref":"Luminous.Panel.html#t:panel_type/0","title":"Luminous.Panel.panel_type/0","type":"type"},{"doc":"","ref":"Luminous.Panel.html#t:t/0","title":"Luminous.Panel.t/0","type":"type"},{"doc":"a query is embedded in a panel and contains a function which will be executed upon panel refresh to fetch the query's data","ref":"Luminous.Query.html","title":"Luminous.Query","type":"behaviour"},{"doc":"initialize a query at compile time the module must implement the Query behaviour","ref":"Luminous.Query.html#define/2","title":"Luminous.Query.define/2","type":"function"},{"doc":"execute the query and return the data as multiple TimeSeries structs","ref":"Luminous.Query.html#execute/3","title":"Luminous.Query.execute/3","type":"function"},{"doc":"a module must implement this behaviour to be passed as an argument to define/3 a query must return a list of 2-tuples: the 2-tuple's first element is the time series' label the 2-tuple's second element is the label's value the list must contain a 2-tuple with the label :time and a DateTime value","ref":"Luminous.Query.html#c:query/3","title":"Luminous.Query.query/3","type":"callback"},{"doc":"","ref":"Luminous.Query.html#t:t/0","title":"Luminous.Query.t/0","type":"type"},{"doc":"This struct collects all the attributes that apply to a particular Dataset it is specified in the attrs argument of Query.result.new","ref":"Luminous.Query.Attributes.html","title":"Luminous.Query.Attributes","type":"module"},{"doc":"","ref":"Luminous.Query.Attributes.html#define/0","title":"Luminous.Query.Attributes.define/0","type":"function"},{"doc":"","ref":"Luminous.Query.Attributes.html#define/1","title":"Luminous.Query.Attributes.define/1","type":"function"},{"doc":"","ref":"Luminous.Query.Attributes.html#t:t/0","title":"Luminous.Query.Attributes.t/0","type":"type"},{"doc":"a DataSet essentially wraps a list of 1-d or 2-d data points that has a label and a type (for visualization)","ref":"Luminous.Query.DataSet.html","title":"Luminous.Query.DataSet","type":"module"},{"doc":"extract and return the first value out of rows e.g. for use in stat panels","ref":"Luminous.Query.DataSet.html#first_value/1","title":"Luminous.Query.DataSet.first_value/1","type":"function"},{"doc":"override the dataset's unit with the provided string only if it's not already present","ref":"Luminous.Query.DataSet.html#maybe_override_unit/2","title":"Luminous.Query.DataSet.maybe_override_unit/2","type":"function"},{"doc":"","ref":"Luminous.Query.DataSet.html#new/3","title":"Luminous.Query.DataSet.new/3","type":"function"},{"doc":"calculate and return the basic statistics of the dataset in one pass (loop)","ref":"Luminous.Query.DataSet.html#statistics/1","title":"Luminous.Query.DataSet.statistics/1","type":"function"},{"doc":"","ref":"Luminous.Query.DataSet.html#t:row/0","title":"Luminous.Query.DataSet.row/0","type":"type"},{"doc":"","ref":"Luminous.Query.DataSet.html#t:t/0","title":"Luminous.Query.DataSet.t/0","type":"type"},{"doc":"","ref":"Luminous.Query.DataSet.html#t:type/0","title":"Luminous.Query.DataSet.type/0","type":"type"},{"doc":"","ref":"Luminous.Query.DataSet.html#t:value/0","title":"Luminous.Query.DataSet.value/0","type":"type"},{"doc":"a query Result wraps a columnar data frame with multiple variables attrs is a map where keys are variable labels (as specified in the query's select statement) and values are keyword lists with visualization properties for the corresponding Dataset. See Dataset.new/3 for details.","ref":"Luminous.Query.Result.html","title":"Luminous.Query.Result","type":"module"},{"doc":"new/2 can be called in the following ways: with a list of rows, i.e. a list of lists containing 2-tuples {label, value} with a single row, i.e. a list of 2-tuples of the form {label, value} (e.g. in the case of single- or multi- stats) with a single value (for use in a single-valued stat panel with no label)","ref":"Luminous.Query.Result.html#new/2","title":"Luminous.Query.Result.new/2","type":"function"},{"doc":"transform the query Result (multiple variables as columns) to a list of Datasets timestamps are converted to unix time in milliseconds (js-compatible)","ref":"Luminous.Query.Result.html#transform/1","title":"Luminous.Query.Result.transform/1","type":"function"},{"doc":"","ref":"Luminous.Query.Result.html#t:label/0","title":"Luminous.Query.Result.label/0","type":"type"},{"doc":"","ref":"Luminous.Query.Result.html#t:point/0","title":"Luminous.Query.Result.point/0","type":"type"},{"doc":"","ref":"Luminous.Query.Result.html#t:row/0","title":"Luminous.Query.Result.row/0","type":"type"},{"doc":"","ref":"Luminous.Query.Result.html#t:t/0","title":"Luminous.Query.Result.t/0","type":"type"},{"doc":"","ref":"Luminous.Query.Result.html#t:value/0","title":"Luminous.Query.Result.value/0","type":"type"},{"doc":"","ref":"Luminous.Router.html","title":"Luminous.Router","type":"module"},{"doc":"","ref":"Luminous.Router.html#browser/2","title":"Luminous.Router.browser/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"Luminous.Router.html#call/2","title":"Luminous.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"Luminous.Router.html#init/1","title":"Luminous.Router.init/1","type":"function"},{"doc":"Module with named helpers generated from Luminous.Router.","ref":"Luminous.Router.Helpers.html","title":"Luminous.Router.Helpers","type":"module"},{"doc":"","ref":"Luminous.Router.Helpers.html#demo_dashboard_path/2","title":"Luminous.Router.Helpers.demo_dashboard_path/2","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#demo_dashboard_path/3","title":"Luminous.Router.Helpers.demo_dashboard_path/3","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#demo_dashboard_url/2","title":"Luminous.Router.Helpers.demo_dashboard_url/2","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#demo_dashboard_url/3","title":"Luminous.Router.Helpers.demo_dashboard_url/3","type":"function"},{"doc":"Generates the path information including any necessary prefix.","ref":"Luminous.Router.Helpers.html#path/2","title":"Luminous.Router.Helpers.path/2","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"Luminous.Router.Helpers.html#static_integrity/2","title":"Luminous.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"Luminous.Router.Helpers.html#static_path/2","title":"Luminous.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"Luminous.Router.Helpers.html#static_url/2","title":"Luminous.Router.Helpers.static_url/2","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#test_dashboard_path/2","title":"Luminous.Router.Helpers.test_dashboard_path/2","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#test_dashboard_path/3","title":"Luminous.Router.Helpers.test_dashboard_path/3","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#test_dashboard_url/2","title":"Luminous.Router.Helpers.test_dashboard_url/2","type":"function"},{"doc":"","ref":"Luminous.Router.Helpers.html#test_dashboard_url/3","title":"Luminous.Router.Helpers.test_dashboard_url/3","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"Luminous.Router.Helpers.html#url/1","title":"Luminous.Router.Helpers.url/1","type":"function"},{"doc":"","ref":"Luminous.Socket.html","title":"Luminous.Socket","type":"module"},{"doc":"","ref":"Luminous.TimeRange.html","title":"Luminous.TimeRange","type":"module"},{"doc":"","ref":"Luminous.TimeRange.html#add/3","title":"Luminous.TimeRange.add/3","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#from_iso/2","title":"Luminous.TimeRange.from_iso/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#from_unix/2","title":"Luminous.TimeRange.from_unix/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#last_month/1","title":"Luminous.TimeRange.last_month/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#last_n_days/2","title":"Luminous.TimeRange.last_n_days/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#last_week/1","title":"Luminous.TimeRange.last_week/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#new/2","title":"Luminous.TimeRange.new/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#next_n_days/2","title":"Luminous.TimeRange.next_n_days/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#round/2","title":"Luminous.TimeRange.round/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#shift_zone!/2","title":"Luminous.TimeRange.shift_zone!/2","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#this_month/1","title":"Luminous.TimeRange.this_month/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#this_week/1","title":"Luminous.TimeRange.this_week/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#to_map/1","title":"Luminous.TimeRange.to_map/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#today/1","title":"Luminous.TimeRange.today/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#tomorrow/1","title":"Luminous.TimeRange.tomorrow/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#yesterday/1","title":"Luminous.TimeRange.yesterday/1","type":"function"},{"doc":"","ref":"Luminous.TimeRange.html#t:t/0","title":"Luminous.TimeRange.t/0","type":"type"},{"doc":"a selector represents the widget in the dashboard that allows for selecting a time range/period it is defined at compile time and populated at compile time (current value) it can also be updated with a new value","ref":"Luminous.TimeRangeSelector.html","title":"Luminous.TimeRangeSelector","type":"behaviour"},{"doc":"this behaviour needs to be implemented by the module that is passed to define/2","ref":"Luminous.TimeRangeSelector.html#c:default_time_range/1","title":"Luminous.TimeRangeSelector.default_time_range/1","type":"callback"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#default_time_range/2","title":"Luminous.TimeRangeSelector.default_time_range/2","type":"function"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#define/2","title":"Luminous.TimeRangeSelector.define/2","type":"function"},{"doc":"Calculates and returns the time range for the given preset in the given time zone.","ref":"Luminous.TimeRangeSelector.html#get_time_range_for/3","title":"Luminous.TimeRangeSelector.get_time_range_for/3","type":"function"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#populate/2","title":"Luminous.TimeRangeSelector.populate/2","type":"function"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#presets/0","title":"Luminous.TimeRangeSelector.presets/0","type":"function"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#update_current/2","title":"Luminous.TimeRangeSelector.update_current/2","type":"function"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#t:preset/0","title":"Luminous.TimeRangeSelector.preset/0","type":"type"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#t:t/0","title":"Luminous.TimeRangeSelector.t/0","type":"type"},{"doc":"","ref":"Luminous.TimeRangeSelector.html#t:time_zone/0","title":"Luminous.TimeRangeSelector.time_zone/0","type":"type"},{"doc":"a variable is defined at compile time and its values are determined at runtime it also stores a current value that can be updated a variable value is descriptive in that it contains a label (for display purposes) and the actual value","ref":"Luminous.Variable.html","title":"Luminous.Variable","type":"behaviour"},{"doc":"defines a new variable and returns the struct does not calculate the values yet (see populate/1 below) the module must implement the Variable behaviour","ref":"Luminous.Variable.html#define/3","title":"Luminous.Variable.define/3","type":"function"},{"doc":"extract the label from the descriptive variable value","ref":"Luminous.Variable.html#extract_label/1","title":"Luminous.Variable.extract_label/1","type":"function"},{"doc":"extract the value from the descriptive variable value","ref":"Luminous.Variable.html#extract_value/1","title":"Luminous.Variable.extract_value/1","type":"function"},{"doc":"find and return the variable with the specified id in the supplied variables","ref":"Luminous.Variable.html#find/2","title":"Luminous.Variable.find/2","type":"function"},{"doc":"returns the variable's current (descriptive) value (or nil)","ref":"Luminous.Variable.html#get_current/1","title":"Luminous.Variable.get_current/1","type":"function"},{"doc":"find the variable with the supplied id in the supplied variables and return its current extracted value","ref":"Luminous.Variable.html#get_current_and_extract_value/2","title":"Luminous.Variable.get_current_and_extract_value/2","type":"function"},{"doc":"uses the query to populate the var's values and returns the new struct also sets the current value to be the first of the calculated values","ref":"Luminous.Variable.html#populate/1","title":"Luminous.Variable.populate/1","type":"function"},{"doc":"replaces the variables current value with the new value and returns the new struct performs a check whether the supplied value is a valid value (i.e. exists in values) if it's not, then it returns the struct unchanged","ref":"Luminous.Variable.html#update_current/2","title":"Luminous.Variable.update_current/2","type":"function"},{"doc":"a module must implement this behaviour to be passed as an argument to define/3","ref":"Luminous.Variable.html#c:variable/1","title":"Luminous.Variable.variable/1","type":"callback"},{"doc":"","ref":"Luminous.Variable.html#t:descriptive_value/0","title":"Luminous.Variable.descriptive_value/0","type":"type"},{"doc":"","ref":"Luminous.Variable.html#t:simple_value/0","title":"Luminous.Variable.simple_value/0","type":"type"},{"doc":"","ref":"Luminous.Variable.html#t:t/0","title":"Luminous.Variable.t/0","type":"type"},{"doc":"Luminous Luminous is a framework for creating dashboards within Phoenix Live View . It is somewhat inspired by grafana both conceptually and functionally in that: it focuses on time series data (albeit not exclusively) it is organized around panels it is parameterized by a time range it can be parameterized by user-defined variables Dashboards are defined at compile time using elixir code (see Luminous.Dashboard.define/5 ). At runtime, Luminous uses the following javascript libraries (as live view hooks ) for supporting client-side visualizations and interactions with the live view process: chartjs for plots flatpickr for time range selection Luminous is currently used in production systems and has demonstrated solid performance and stability characteristics. At the same time, it is currently under development and some things may change.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package is not yet published to hex.pm but can be installed directly from this repo by adding luminous to your list of dependencies in mix.exs like so: def deps do [ { :luminous , git : &quot;https://github.com/elinverd/luminous.git&quot; , branch : &quot;main&quot; } ] end luminous assumes that it will be embedded in a standard Phoenix LiveView application with tailwindcss . In order to be able to use the provided components, the library's javascript and CSS files must be imported to your project: In assets/package.json : ... &quot;dependencies&quot;: { &quot;luminous&quot;: &quot;file:../deps/luminous&quot; } In assets/js/app.js : import { ChartJSHook, TimeRangeHook } from &quot;luminous&quot; let Hooks = { TimeRangeHook: new TimeRangeHook(), ChartJSHook: new ChartJSHook() } ... let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, { ... hooks: Hooks }) ... Finally, in assets/css/app.css : @import &quot;luminous/dist/luminous&quot;;","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"A demo dashboard has been provided that showcases some of Luminous' capabilities. The demo can be inspected live using the project's dev server (run mix dev in the project and then visit this page ). Luminous is a framework in the sense that the luminous client is responsible for specifying queries, variables etc. and Luminous.Live will call the client's code by setting up all the required plumbing. In general, a custom dashboard needs to: implement the Luminous.Variable behaviour for the dashboard-specific variables implement the Luminous.Query behaviour for loading the necessary data that will be visualized in the client implement the Luminous.TimeRangeSelector behaviour for determining the default time range for the dashboard use the Luminous.Live module for leveraging the live dashboard functionality and capabilities render the dashboard in the view template (only Luminous.Components.dashboard is necessary but the layout can be customized by using directly the various components in Luminous.Components )","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Time range selection and refresh of all dashboard panel queries Asynchronous queries and page updates User-facing variable dropdowns that are available to panel queries Client-side zoom in charts Multiple supported chart types (currently :line and :bar ) Download panel data (CSV, PNG) Stat panels (show single or multiple stats) Summary statistics in panels","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/luminous .","ref":"readme.html#development","title":"README - Development","type":"extras"},{"doc":"luminous provides CSS classes that can be overriden, so that the components match the look and feel of the consumer application. Those classes belong to three luminous components: Variables Time range selector Panel dropdown Variables lmn-variable-button Define the size, shape, background color, on hover behavior, etc. of the variable buttons. lmn-variable-button-label Define the font, text size, weight, alignment of the variable button's label. lmn-variable-button-label-prefix Define the font, text size, weight, alignment of the variable button's label prefix. lmn-variable-button-icon Define the size and alignment of the variable button's chevron icon. lmn-variable-dropdown Define the size, background color, rouding, shadows, etc. of the variable dropdown menu. lmn-variable-dropdown-item-container Define the text alignment, rounding, on hover behaviour, etc. of each item in the variable dropdown menu. lmn-variable-dropdown-item-content Define the size, padding, etc. of the content of each item in the variable dropdown menu. Time range picker lmn-time-range-compound Define the structure of the time range component. This includes the time range picker button, the pressets button and the time zone component. lmn-time-range-selector Define the structure, the size and the shape of the time range selector component. This includes the button that opens the custom time range selector and the button that opens the preset menu dropdown. lmn-custom-time-range-input Define the size, background color, text size, on hover behavior, etc. of the button that opens the custom date range picker dropdown. lmn-time-range-presets-button Define the size, background color, on hover behavior, etc. of the button that opens the time range presets dropdown. lmn-time-range-presets-button-icon Define the size and spacing of the icon in the button that opens the time range presets dropdown. lmn-time-range-presets-dropdown Define the size, background color, rouding, shadows, etc. of the time range presets dropdown menu. lmn-time-range-presets-dropdown-item-container Define the text alignment, rounding, on hover behaviour, etc. of each item in the time range presets dropdown menu. lmn-time-range-presets-dropdown-item-content Define the size, padding, etc. of the content of each item in the time range presets dropdown menu. lmn-time-zone Define the background color, rounding, text size, etc. of the time zone label Panel dropdown lmn-panel-actions-dropdown Define the size, background color, rouding, shadows, etc. of the panel actions dropdown menu. lmn-panel-actions-dropdown-item-container Define the text alignment, rounding, on hover behaviour, etc. of each item in the panel actions dropdown menu. lmn-panel-actions-dropdown-item-content Define the size, padding, etc. of the content of each item in the panel actions dropdown menu. Dropdown transition lmn-dropdown-transition-enter Define the animation of all dropdowns when they open up. lmn-dropdown-transition-start Define the initial state of the animation of all dropdowns when they open up. lmn-dropdown-transition-end Define the final state of the animation of all dropdowns when they open up. Calendar dropdown For the calendar dropdown, by default we use the airbnb theme provided by flatpickr . To change this theme, you have to import the desired theme after importing luminous to your app.css file like so: @import 'luminous/dist/luminous'; @import '../node_modules/flatpickr/dist/themes/material_blue.css'; The path that the flatpickr theme resides, depends on your project's directory structure.","ref":"applying-custom-css.html","title":"Applying custom CSS","type":"extras"}]